Index: uspace/srv/net/tl/icmp/icmp.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp.c	(revision 22027b6e7981eafebc4220c771cc114cfcc00c1f)
+++ uspace/srv/net/tl/icmp/icmp.c	(revision 8b5690f2670aee6dddfa3127ce14232d1d21555d)
@@ -33,9 +33,5 @@
 /** @file
  * ICMP module implementation.
- * @see icmp.h
- */
-
-#include "icmp.h"
-#include "icmp_module.h"
+ */
 
 #include <async.h>
@@ -45,5 +41,4 @@
 #include <stdint.h>
 #include <str.h>
-#include <ipc/ipc.h>
 #include <ipc/services.h>
 #include <ipc/net.h>
@@ -54,4 +49,5 @@
 #include <byteorder.h>
 #include <errno.h>
+#include <adt/hash_table.h>
 
 #include <net/socket_codes.h>
@@ -67,38 +63,35 @@
 #include <net_checksum.h>
 #include <icmp_client.h>
-#include <icmp_interface.h>
-#include <il_interface.h>
+#include <icmp_remote.h>
+#include <il_remote.h>
 #include <ip_client.h>
 #include <ip_interface.h>
 #include <net_interface.h>
-#include <tl_interface.h>
-#include <tl_local.h>
+#include <tl_remote.h>
+#include <tl_skel.h>
 #include <icmp_header.h>
 
-/** ICMP module name. */
-#define NAME	"ICMP protocol"
-
-/** Default ICMP error reporting. */
-#define NET_DEFAULT_ICMP_ERROR_REPORTING	true
-
-/** Default ICMP echo replying. */
-#define NET_DEFAULT_ICMP_ECHO_REPLYING		true
-
-/** Original datagram length in bytes transfered to the error notification
- * message.
- */
-#define ICMP_KEEP_LENGTH	8
-
-/** Free identifier numbers pool start. */
-#define ICMP_FREE_IDS_START	1
-
-/** Free identifier numbers pool end. */
-#define ICMP_FREE_IDS_END	UINT16_MAX
-
-/** Computes the ICMP datagram checksum.
- *
- * @param[in,out] header The ICMP datagram header.
- * @param[in] length	The total datagram length.
- * @return		The computed checksum.
+/** ICMP module name */
+#define NAME  "icmp"
+
+/** Number of replies hash table keys */
+#define REPLY_KEYS  2
+
+/** Number of replies hash table buckets */
+#define REPLY_BUCKETS  1024
+
+/**
+ * Original datagram length in bytes transfered to the error
+ * notification message.
+ */
+#define ICMP_KEEP_LENGTH  8
+
+/** Compute the ICMP datagram checksum.
+ *
+ * @param[in,out] header ICMP datagram header.
+ * @param[in]     length Total datagram length.
+ *
+ * @return Computed checksum.
+ *
  */
 #define ICMP_CHECKSUM(header, length) \
@@ -106,181 +99,222 @@
 
 /** An echo request datagrams pattern. */
-#define ICMP_ECHO_TEXT		"Hello from HelenOS."
-
-/** Computes an ICMP reply data key.
- *
- * @param[in] id	The message identifier.
- * @param[in] sequence	The message sequence number.
- * @return		The computed ICMP reply data key.
- */
-#define ICMP_GET_REPLY_KEY(id, sequence) \
-	(((id) << 16) | (sequence & 0xFFFF))
-
-
-/** ICMP global data. */
-icmp_globals_t	icmp_globals;
-
-INT_MAP_IMPLEMENT(icmp_replies, icmp_reply_t);
-INT_MAP_IMPLEMENT(icmp_echo_data, icmp_echo_t);
-
-/** Releases the packet and returns the result.
- *
- * @param[in] packet	The packet queue to be released.
- * @param[in] result	The result to be returned.
- * @return		The result parameter.
- */
-static int icmp_release_and_return(packet_t *packet, int result)
-{
-	pq_release_remote(icmp_globals.net_phone, packet_get_id(packet));
-	return result;
-}
-
-/** Sends the ICMP message.
- *
- * Sets the message type and code and computes the checksum.
+#define ICMP_ECHO_TEXT  "ICMP hello from HelenOS."
+
+/** ICMP reply data. */
+typedef struct {
+	/** Hash table link */
+	link_t link;
+	
+	/** Reply identification and sequence */
+	icmp_param_t id;
+	icmp_param_t sequence;
+	
+	/** Reply signaling */
+	fibril_condvar_t condvar;
+	
+	/** Reply result */
+	int result;
+} icmp_reply_t;
+
+/** Global data */
+static int phone_net = -1;
+static int phone_ip = -1;
+static bool error_reporting = true;
+static bool echo_replying = true;
+static packet_dimension_t icmp_dimension;
+
+/** ICMP client identification counter */
+static atomic_t icmp_client;
+
+/** ICMP identifier and sequence number (client-specific) */
+static fibril_local icmp_param_t icmp_id;
+static fibril_local icmp_param_t icmp_seq;
+
+/** Reply hash table */
+static fibril_mutex_t reply_lock;
+static hash_table_t replies;
+
+static hash_index_t replies_hash(unsigned long key[])
+{
+	/*
+	 * ICMP identifier and sequence numbers
+	 * are 16-bit values.
+	 */
+	hash_index_t index = ((key[0] & 0xffff) << 16) | (key[1] & 0xffff);
+	return (index % REPLY_BUCKETS);
+}
+
+static int replies_compare(unsigned long key[], hash_count_t keys, link_t *item)
+{
+	icmp_reply_t *reply =
+	    hash_table_get_instance(item, icmp_reply_t, link);
+	
+	if (keys == 1)
+		return (reply->id == key[0]);
+	else
+		return ((reply->id == key[0]) && (reply->sequence == key[1]));
+}
+
+static void replies_remove_callback(link_t *item)
+{
+}
+
+static hash_table_operations_t reply_ops = {
+	.hash = replies_hash,
+	.compare = replies_compare,
+	.remove_callback = replies_remove_callback
+};
+
+/** Release the packet and return the result.
+ *
+ * @param[in] packet Packet queue to be released.
+ *
+ */
+static void icmp_release(packet_t *packet)
+{
+	pq_release_remote(phone_net, packet_get_id(packet));
+}
+
+/** Send the ICMP message.
+ *
+ * Set the message type and code and compute the checksum.
  * Error messages are sent only if allowed in the configuration.
- * Releases the packet on errors.
- *
- * @param[in] type	The message type.
- * @param[in] code	The message code.
- * @param[in] packet	The message packet to be sent.
- * @param[in] header	The ICMP header.
- * @param[in] error	The error service to be announced. Should be
- *			SERVICE_ICMP or zero.
- * @param[in] ttl	The time to live.
- * @param[in] tos	The type of service.
- * @param[in] dont_fragment The value indicating whether the datagram must not
- *			be fragmented. Is used as a MTU discovery.
- * @return		EOK on success.
- * @return		EPERM if the error message is not allowed.
- */
-static int icmp_send_packet(icmp_type_t type, icmp_code_t code, packet_t *packet,
-    icmp_header_t *header, services_t error, ip_ttl_t ttl, ip_tos_t tos,
-    int dont_fragment)
-{
-	int rc;
-
+ * Release the packet on errors.
+ *
+ * @param[in] type          Message type.
+ * @param[in] code          Message code.
+ * @param[in] packet        Message packet to be sent.
+ * @param[in] header        ICMP header.
+ * @param[in] error         Error service to be announced. Should be
+ *                          SERVICE_ICMP or zero.
+ * @param[in] ttl           Time to live.
+ * @param[in] tos           Type of service.
+ * @param[in] dont_fragment Disable fragmentation.
+ *
+ * @return EOK on success.
+ * @return EPERM if the error message is not allowed.
+ *
+ */
+static int icmp_send_packet(icmp_type_t type, icmp_code_t code,
+    packet_t *packet, icmp_header_t *header, services_t error, ip_ttl_t ttl,
+    ip_tos_t tos, bool dont_fragment)
+{
 	/* Do not send an error if disabled */
-	if (error && !icmp_globals.error_reporting)
-		return icmp_release_and_return(packet, EPERM);
-
+	if ((error) && (!error_reporting)) {
+		icmp_release(packet);
+		return EPERM;
+	}
+	
 	header->type = type;
 	header->code = code;
+	
+	/*
+	 * The checksum needs to be calculated
+	 * with a virtual checksum field set to
+	 * zero.
+	 */
 	header->checksum = 0;
 	header->checksum = ICMP_CHECKSUM(header,
 	    packet_get_data_length(packet));
 	
-	rc = ip_client_prepare_packet(packet, IPPROTO_ICMP, ttl, tos,
+	int rc = ip_client_prepare_packet(packet, IPPROTO_ICMP, ttl, tos,
 	    dont_fragment, 0);
-	if (rc != EOK)
-		return icmp_release_and_return(packet, rc);
-
-	return ip_send_msg(icmp_globals.ip_phone, -1, packet, SERVICE_ICMP,
-	    error);
-}
-
-/** Prepares the ICMP error packet.
- *
- * Truncates the original packet if longer than ICMP_KEEP_LENGTH bytes.
- * Prefixes and returns the ICMP header.
- *
- * @param[in,out] packet The original packet.
+	if (rc != EOK) {
+		icmp_release(packet);
+		return rc;
+	}
+	
+	return ip_send_msg(phone_ip, -1, packet, SERVICE_ICMP, error);
+}
+
+/** Prepare the ICMP error packet.
+ *
+ * Truncate the original packet if longer than ICMP_KEEP_LENGTH bytes.
+ * Prefix and return the ICMP header.
+ *
+ * @param[in,out] packet Original packet.
+ *
  * @return The prefixed ICMP header.
  * @return NULL on errors.
+ *
  */
 static icmp_header_t *icmp_prepare_packet(packet_t *packet)
 {
-	icmp_header_t *header;
-	size_t header_length;
-	size_t total_length;
-
-	total_length = packet_get_data_length(packet);
+	size_t total_length = packet_get_data_length(packet);
 	if (total_length <= 0)
 		return NULL;
-
-	header_length = ip_client_header_length(packet);
+	
+	size_t header_length = ip_client_header_length(packet);
 	if (header_length <= 0)
 		return NULL;
-
+	
 	/* Truncate if longer than 64 bits (without the IP header) */
 	if ((total_length > header_length + ICMP_KEEP_LENGTH) &&
 	    (packet_trim(packet, 0,
-	    total_length - header_length - ICMP_KEEP_LENGTH) != EOK)) {
+	    total_length - header_length - ICMP_KEEP_LENGTH) != EOK))
 		return NULL;
-	}
-
-	header = PACKET_PREFIX(packet, icmp_header_t);
+	
+	icmp_header_t *header = PACKET_PREFIX(packet, icmp_header_t);
 	if (!header)
 		return NULL;
-
+	
 	bzero(header, sizeof(*header));
 	return header;
 }
 
-/** Requests an echo message.
- *
- * Sends a packet with specified parameters to the target host and waits for
- * the reply upto the given timeout.
- * Blocks the caller until the reply or the timeout occurs.
- *
- * @param[in] id	The message identifier.
- * @param[in] sequence	The message sequence parameter.
- * @param[in] size	The message data length in bytes.
- * @param[in] timeout	The timeout in miliseconds.
- * @param[in] ttl	The time to live.
- * @param[in] tos	The type of service.
- * @param[in] dont_fragment The value indicating whether the datagram must not
- *			be fragmented. Is used as a MTU discovery.
- * @param[in] addr	The target host address.
- * @param[in] addrlen	The torget host address length.
- * @return		ICMP_ECHO on success.
- * @return		ETIMEOUT if the reply has not arrived before the
- *			timeout.
- * @return		ICMP type of the received error notification.
- * @return		EINVAL if the addrlen parameter is less or equal to
- *			zero.
- * @return		ENOMEM if there is not enough memory left.
- * @return		EPARTY if there was an internal error.
+/** Request an echo message.
+ *
+ * Send a packet with specified parameters to the target host
+ * and wait for the reply upto the given timeout.
+ * Block the caller until the reply or the timeout occurs.
+ *
+ * @param[in] id            Message identifier.
+ * @param[in] sequence      Message sequence parameter.
+ * @param[in] size          Message data length in bytes.
+ * @param[in] timeout       Timeout in miliseconds.
+ * @param[in] ttl           Time to live.
+ * @param[in] tos           Type of service.
+ * @param[in] dont_fragment Disable fragmentation.
+ * @param[in] addr          Target host address.
+ * @param[in] addrlen       Torget host address length.
+ *
+ * @return ICMP_ECHO on success.
+ * @return ETIMEOUT if the reply has not arrived before the
+ *         timeout.
+ * @return ICMP type of the received error notification.
+ * @return EINVAL if the addrlen parameter is less or equal to
+ *         zero.
+ * @return ENOMEM if there is not enough memory left.
+ *
  */
 static int icmp_echo(icmp_param_t id, icmp_param_t sequence, size_t size,
-    mseconds_t timeout, ip_ttl_t ttl, ip_tos_t tos, int dont_fragment,
-    const struct sockaddr * addr, socklen_t addrlen)
-{
-	icmp_header_t *header;
-	packet_t *packet;
-	size_t length;
-	uint8_t *data;
-	icmp_reply_t *reply;
-	int reply_key;
-	int index;
-	int rc;
-
+    mseconds_t timeout, ip_ttl_t ttl, ip_tos_t tos, bool dont_fragment,
+    const struct sockaddr *addr, socklen_t addrlen)
+{
 	if (addrlen <= 0)
 		return EINVAL;
-
-	length = (size_t) addrlen;
-	/* TODO do not ask all the time */
-	rc = ip_packet_size_req(icmp_globals.ip_phone, -1,
-	    &icmp_globals.packet_dimension);
-	if (rc != EOK)
-		return rc;
-
-	packet = packet_get_4_remote(icmp_globals.net_phone, size,
-	    icmp_globals.packet_dimension.addr_len,
-	    ICMP_HEADER_SIZE + icmp_globals.packet_dimension.prefix,
-	    icmp_globals.packet_dimension.suffix);
+	
+	size_t length = (size_t) addrlen;
+	
+	packet_t *packet = packet_get_4_remote(phone_net, size,
+	    icmp_dimension.addr_len, ICMP_HEADER_SIZE + icmp_dimension.prefix,
+	    icmp_dimension.suffix);
 	if (!packet)
 		return ENOMEM;
-
+	
 	/* Prepare the requesting packet, set the destination address. */
-	rc = packet_set_addr(packet, NULL, (const uint8_t *) addr, length);
-	if (rc != EOK)
-		return icmp_release_and_return(packet, rc);
-
+	int rc = packet_set_addr(packet, NULL, (const uint8_t *) addr, length);
+	if (rc != EOK) {
+		icmp_release(packet);
+		return rc;
+	}
+	
 	/* Allocate space in the packet */
-	data = (uint8_t *) packet_suffix(packet, size);
-	if (!data)
-		return icmp_release_and_return(packet, ENOMEM);
-
+	uint8_t *data = (uint8_t *) packet_suffix(packet, size);
+	if (!data) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
 	/* Fill the data */
 	length = 0;
@@ -290,116 +324,329 @@
 	}
 	memcpy(data + length, ICMP_ECHO_TEXT, size - length);
-
+	
 	/* Prefix the header */
-	header = PACKET_PREFIX(packet, icmp_header_t);
-	if (!header)
-		return icmp_release_and_return(packet, ENOMEM);
-
-	bzero(header, sizeof(*header));
+	icmp_header_t *header = PACKET_PREFIX(packet, icmp_header_t);
+	if (!header) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
+	bzero(header, sizeof(icmp_header_t));
 	header->un.echo.identifier = id;
 	header->un.echo.sequence_number = sequence;
-
+	
 	/* Prepare the reply structure */
-	reply = malloc(sizeof(*reply));
-	if (!reply)
-		return icmp_release_and_return(packet, ENOMEM);
-
-	fibril_mutex_initialize(&reply->mutex);
-	fibril_mutex_lock(&reply->mutex);
+	icmp_reply_t *reply = malloc(sizeof(icmp_reply_t));
+	if (!reply) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
+	reply->id = id;
+	reply->sequence = sequence;
 	fibril_condvar_initialize(&reply->condvar);
-	reply_key = ICMP_GET_REPLY_KEY(header->un.echo.identifier,
-	    header->un.echo.sequence_number);
-	index = icmp_replies_add(&icmp_globals.replies, reply_key, reply);
-	if (index < 0) {
-		free(reply);
-		return icmp_release_and_return(packet, index);
-	}
-
-	/* Unlock the globals so that we can wait for the reply */
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
-
+	
+	/* Add the reply to the replies hash table */
+	fibril_mutex_lock(&reply_lock);
+	
+	unsigned long key[REPLY_KEYS] = {id, sequence};
+	hash_table_insert(&replies, key, &reply->link);
+	
 	/* Send the request */
 	icmp_send_packet(ICMP_ECHO, 0, packet, header, 0, ttl, tos,
 	    dont_fragment);
-
+	
 	/* Wait for the reply. Timeout in microseconds. */
-	rc = fibril_condvar_wait_timeout(&reply->condvar, &reply->mutex,
+	rc = fibril_condvar_wait_timeout(&reply->condvar, &reply_lock,
 	    timeout * 1000);
 	if (rc == EOK)
 		rc = reply->result;
-
-	/* Drop the reply mutex before locking the globals again */
-	fibril_mutex_unlock(&reply->mutex);
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-
-	/* Destroy the reply structure */
-	icmp_replies_exclude_index(&icmp_globals.replies, index);
-
+	
+	/* Remove the reply from the replies hash table */
+	hash_table_remove(&replies, key, REPLY_KEYS);
+	
+	fibril_mutex_unlock(&reply_lock);
+	
+	free(reply);
+	
 	return rc;
 }
 
-static int icmp_destination_unreachable_msg_local(int icmp_phone,
-    icmp_code_t code, icmp_param_t mtu, packet_t *packet)
-{
-	icmp_header_t *header;
-
-	header = icmp_prepare_packet(packet);
-	if (!header)
-		return icmp_release_and_return(packet, ENOMEM);
-
+static int icmp_destination_unreachable(icmp_code_t code, icmp_param_t mtu,
+    packet_t *packet)
+{
+	icmp_header_t *header = icmp_prepare_packet(packet);
+	if (!header) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
 	if (mtu)
 		header->un.frag.mtu = mtu;
-
+	
 	return icmp_send_packet(ICMP_DEST_UNREACH, code, packet, header,
-	    SERVICE_ICMP, 0, 0, 0);
-}
-
-static int icmp_source_quench_msg_local(int icmp_phone, packet_t *packet)
-{
-	icmp_header_t *header;
-
-	header = icmp_prepare_packet(packet);
-	if (!header)
-		return icmp_release_and_return(packet, ENOMEM);
-
+	    SERVICE_ICMP, 0, 0, false);
+}
+
+static int icmp_source_quench(packet_t *packet)
+{
+	icmp_header_t *header = icmp_prepare_packet(packet);
+	if (!header) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
 	return icmp_send_packet(ICMP_SOURCE_QUENCH, 0, packet, header,
-	    SERVICE_ICMP, 0, 0, 0);
-}
-
-static int icmp_time_exceeded_msg_local(int icmp_phone, icmp_code_t code,
+	    SERVICE_ICMP, 0, 0, false);
+}
+
+static int icmp_time_exceeded(icmp_code_t code, packet_t *packet)
+{
+	icmp_header_t *header = icmp_prepare_packet(packet);
+	if (!header) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
+	return icmp_send_packet(ICMP_TIME_EXCEEDED, code, packet, header,
+	    SERVICE_ICMP, 0, 0, false);
+}
+
+static int icmp_parameter_problem(icmp_code_t code, icmp_param_t pointer,
     packet_t *packet)
 {
-	icmp_header_t *header;
-
-	header = icmp_prepare_packet(packet);
-	if (!header)
-		return icmp_release_and_return(packet, ENOMEM);
-
-	return icmp_send_packet(ICMP_TIME_EXCEEDED, code, packet, header,
-	    SERVICE_ICMP, 0, 0, 0);
-}
-
-static int icmp_parameter_problem_msg_local(int icmp_phone, icmp_code_t code,
-    icmp_param_t pointer, packet_t *packet)
-{
-	icmp_header_t *header;
-
-	header = icmp_prepare_packet(packet);
-	if (!header)
-		return icmp_release_and_return(packet, ENOMEM);
-
+	icmp_header_t *header = icmp_prepare_packet(packet);
+	if (!header) {
+		icmp_release(packet);
+		return ENOMEM;
+	}
+	
 	header->un.param.pointer = pointer;
 	return icmp_send_packet(ICMP_PARAMETERPROB, code, packet, header,
-	    SERVICE_ICMP, 0, 0, 0);
-}
-
-/** Initializes the ICMP module.
- *
- * @param[in] client_connection The client connection processing function. The
- *			module skeleton propagates its own one.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
- */
-int icmp_initialize(async_client_conn_t client_connection)
+	    SERVICE_ICMP, 0, 0, false);
+}
+
+/** Try to set the pending reply result as the received message type.
+ *
+ * If the reply data is not present, the reply timed out and the other fibril
+ * is already awake. The packet is released.
+ *
+ * @param[in] packet The received reply message.
+ * @param[in] header The ICMP message header.
+ * @param[in] type   The received reply message type.
+ * @param[in] code   The received reply message code.
+ *
+ */
+static void icmp_process_echo_reply(packet_t *packet, icmp_header_t *header,
+    icmp_type_t type, icmp_code_t code)
+{
+	unsigned long key[REPLY_KEYS] =
+	    {header->un.echo.identifier, header->un.echo.sequence_number};
+	
+	/* The packet is no longer needed */
+	icmp_release(packet);
+	
+	/* Find the pending reply */
+	fibril_mutex_lock(&reply_lock);
+	
+	link_t *link = hash_table_find(&replies, key);
+	if (link != NULL) {
+		icmp_reply_t *reply =
+		   hash_table_get_instance(link, icmp_reply_t, link);
+		
+		reply->result = type;
+		fibril_condvar_signal(&reply->condvar);
+	}
+	
+	fibril_mutex_unlock(&reply_lock);
+}
+
+/** Process the received ICMP packet.
+ *
+ * Notify the destination socket application.
+ *
+ * @param[in,out] packet Received packet.
+ * @param[in]     error  Packet error reporting service to prefix
+ *                       the received packet.
+ *
+ * @return EOK on success.
+ * @return EINVAL if the packet is not valid.
+ * @return EINVAL if the stored packet address is not the an_addr_t.
+ * @return EINVAL if the packet does not contain any data.
+ * @return NO_DATA if the packet content is shorter than the user
+ *         datagram header.
+ * @return ENOMEM if there is not enough memory left.
+ * @return EADDRNOTAVAIL if the destination socket does not exist.
+ * @return Other error codes as defined for the
+ *         ip_client_process_packet() function.
+ *
+ */
+static int icmp_process_packet(packet_t *packet, services_t error)
+{
+	icmp_type_t type;
+	icmp_code_t code;
+	int rc;
+	
+	switch (error) {
+	case SERVICE_NONE:
+		break;
+	case SERVICE_ICMP:
+		/* Process error */
+		rc = icmp_client_process_packet(packet, &type, &code, NULL, NULL);
+		if (rc < 0)
+			return rc;
+		
+		/* Remove the error header */
+		rc = packet_trim(packet, (size_t) rc, 0);
+		if (rc != EOK)
+			return rc;
+		
+		break;
+	default:
+		return ENOTSUP;
+	}
+	
+	/* Get rid of the IP header */
+	size_t length = ip_client_header_length(packet);
+	rc = packet_trim(packet, length, 0);
+	if (rc != EOK)
+		return rc;
+	
+	length = packet_get_data_length(packet);
+	if (length <= 0)
+		return EINVAL;
+	
+	if (length < ICMP_HEADER_SIZE)
+		return EINVAL;
+	
+	void *data = packet_get_data(packet);
+	if (!data)
+		return EINVAL;
+	
+	/* Get ICMP header */
+	icmp_header_t *header = (icmp_header_t *) data;
+	
+	if (header->checksum) {
+		while (ICMP_CHECKSUM(header, length) != IP_CHECKSUM_ZERO) {
+			/*
+			 * Set the original message type on error notification.
+			 * Type swap observed in Qemu.
+			 */
+			if (error) {
+				switch (header->type) {
+				case ICMP_ECHOREPLY:
+					header->type = ICMP_ECHO;
+					continue;
+				}
+			}
+			
+			return EINVAL;
+		}
+	}
+	
+	switch (header->type) {
+	case ICMP_ECHOREPLY:
+		if (error)
+			icmp_process_echo_reply(packet, header, type, code);
+		else
+			icmp_process_echo_reply(packet, header, ICMP_ECHO, 0);
+		
+		return EOK;
+	
+	case ICMP_ECHO:
+		if (error) {
+			icmp_process_echo_reply(packet, header, type, code);
+			return EOK;
+		}
+		
+		/* Do not send a reply if disabled */
+		if (echo_replying) {
+			uint8_t *src;
+			int addrlen = packet_get_addr(packet, &src, NULL);
+			
+			/*
+			 * Set both addresses to the source one (avoid the
+			 * source address deletion before setting the
+			 * destination one).
+			 */
+			if ((addrlen > 0) && (packet_set_addr(packet, src, src,
+			    (size_t) addrlen) == EOK)) {
+				/* Send the reply */
+				icmp_send_packet(ICMP_ECHOREPLY, 0, packet,
+				    header, 0, 0, 0, 0);
+				return EOK;
+			}
+			
+			return EINVAL;
+		}
+		
+		return EPERM;
+	
+	case ICMP_DEST_UNREACH:
+	case ICMP_SOURCE_QUENCH:
+	case ICMP_REDIRECT:
+	case ICMP_ALTERNATE_ADDR:
+	case ICMP_ROUTER_ADV:
+	case ICMP_ROUTER_SOL:
+	case ICMP_TIME_EXCEEDED:
+	case ICMP_PARAMETERPROB:
+	case ICMP_CONVERSION_ERROR:
+	case ICMP_REDIRECT_MOBILE:
+	case ICMP_SKIP:
+	case ICMP_PHOTURIS:
+		ip_received_error_msg(phone_ip, -1, packet,
+		    SERVICE_IP, SERVICE_ICMP);
+		return EOK;
+	
+	default:
+		return ENOTSUP;
+	}
+}
+
+/** Process IPC messages from the IP module
+ *
+ * @param[in]     iid   Message identifier.
+ * @param[in,out] icall Message parameters.
+ *
+ */
+static void icmp_receiver(ipc_callid_t iid, ipc_call_t *icall)
+{
+	bool loop = true;
+	packet_t *packet;
+	int rc;
+	
+	while (loop) {
+		switch (IPC_GET_IMETHOD(*icall)) {
+		case NET_TL_RECEIVED:
+			rc = packet_translate_remote(phone_net, &packet,
+			    IPC_GET_PACKET(*icall));
+			if (rc == EOK) {
+				rc = icmp_process_packet(packet, IPC_GET_ERROR(*icall));
+				if (rc != EOK)
+					icmp_release(packet);
+			}
+			
+			async_answer_0(iid, (sysarg_t) rc);
+			break;
+		case IPC_M_PHONE_HUNGUP:
+			loop = false;
+			continue;
+		default:
+			async_answer_0(iid, (sysarg_t) ENOTSUP);
+		}
+		
+		iid = async_get_call(icall);
+	}
+}
+
+/** Initialize the ICMP module.
+ *
+ * @param[in] net_phone Network module phone.
+ *
+ * @return EOK on success.
+ * @return ENOMEM if there is not enough memory left.
+ *
+ */
+int tl_initialize(int net_phone)
 {
 	measured_string_t names[] = {
